C***********************************************************************
C $Id: arundo.f,v 3.7 2005/02/24 15:22:08 nils Exp $

      SUBROUTINE ARUNDO(I1I,I2I,I3I)

C...ARiadne function UNDO

C...Try to undo a previous emission fixing up recoils etc.

      INCLUDE 'arimpl.f'
      INCLUDE 'arpart.f'
      INCLUDE 'ardat1.f'
      INCLUDE 'pydat1.f'
      INCLUDE 'arhide.f'
      INCLUDE 'ardble.f'
      INCLUDE 'pyjets.f'
      INCLUDE 'ardips.f'
      INCLUDE 'arstrf.f'
      
      DIMENSION IPAR(MAXPAR), SBP(5)

      I1=I1I
      I2=I2I
      I3=I3I
      IF(I3.EQ.MAXPAR-3 .OR. I3.EQ.MAXPAR-4)THEN
C...Undo the emission of a quark from a proton remnant
C...Set the KFSAVE vector
        IF(I3.EQ.MAXPAR-4)THEN
          KFSAVE(1) = 21
        ELSE
          KFSAVE(2) = 21
        ENDIF

        CALL ARFPA3(I1, I2, I3, IPAR, INP, SBP)
        IF(INP .LT. 1)THEN
          WRITE(*,*) 'ARUNDO: Error ARFPA3 found no particles'
        ENDIF
C...Calculate the sum of the fourvectors
        DO 300 I = 1,5
          IF(QQ(I3))THEN
            BP(IPART+1, I) = BP(I1, I) + BP(I3, I)
          ELSE
            BP(IPART+1, I) = BP(I1, I)
          ENDIF
          BP(IPART+2, I) = BP(I2, I)
          BP(IPART+3, I) = SBP(I)
 300    CONTINUE
C...Boost to CM
        CALL ARBCM3(IPART+1, IPART+2, IPART+3, THE, PHI1, PHI3, DBEX, 
     $    DBEY, DBEZ)
        S = ARMAS3(IPART+1, IPART+2, IPART+3)

        CALL ARROBO(0.0D0,0.0D0,-DBEX,-DBEY,-DBEZ,INP,IPAR)
        CALL ARROBO(0.0D0,-PHI1,0.0D0,0.0D0,0.0D0,INP,IPAR)
        CALL ARROBO(-THE,-PHI3,0.0D0,0.0D0,0.0D0,INP,IPAR)

C...Rotate the particles
        ALP=ARANGL(IPART+1, IPART+3)
        PSI=(ARX2DB(PARU(1))-ALP)

        CALL ARROBO(PSI,0.0D0,0.0D0,0.0D0,0.0D0,INP,IPAR)
        CALL AROBO1(PSI,0.0D0,0.0D0,0.0D0,0.0D0,IPART+3)

        IF(QQ(I3))THEN
          CALL AROBO2(0.0D0,0.0D0,-DBEX,-DBEY,-DBEZ,I1,I3)
          CALL AROBO2(0.0D0,-PHI1,0.0D0,0.0D0,0.0D0,I1,I3)
          CALL AROBO2(-THE,-PHI3,0.0D0,0.0D0,0.0D0,I1,I3)

          QSEA = .FALSE.
          CALL ARRFLV(IFL(I3), -IFL(I2), QSEA, KFR1, KFR2, KFH)
          IF(QSEA) WRITE(*,*) 'ARDUNDO: Warning inconsistant flavours'

          DO 310 I = 1,5
            BP(I2,I) = BP(I3,I)
 310      CONTINUE

          XPMU(I2) = XPMU(I3)
          XPA(I2) = XPA(I3)
          INQ(I2) = INQ(I1)
          QEX(I2) = .TRUE.
          IFL(I2) = KFR1
          QQ(I3) = .FALSE.

          BP(I2, 5) = PYMASS(IFL(I2))
          PPLUS = BP(I2, 4) + BP(I2,3)
          PMINUS = (BP(I2,5)**2+BP(I2,1)**2+BP(I2,2)**2)/PPLUS
          BP(I2,4) = (PPLUS+PMINUS)/2
          BP(I2,3) = (PPLUS-PMINUS)/2

          SPR = SQRT(ARMAS2(I2,I1))

          PPN = ARPCMS(S, SPR, SBP(5))
          PPO = BP(I1,4)+BP(I1,3) + BP(I2,4)+BP(I2,3)
          PPBZ = (PPN**2 - PPO**2)/(PPN**2 + PPO**2)

          CALL AROBO2(0.0D0,0.0D0,0.0D0,0.0D0,PPBZ,I1,I2)

        ELSE
          BP(I2, 5) = PYMASS(IFL(I2))
          QEX(I2) = .TRUE.
          XPMU(I2) = XPMU(I1)
          XPA(I2) = XPA(I1)
          INQ(I2) = INQ(I1)

 400      CALL PYPTDI(IFL(I2),PX,PY)
          DMT2R1 = BP(I1,5)**2+PX**2+PY**2
          DMT2R2 = BP(I2,5)**2+PX**2+PY**2
          CALL PYZDIS(IFL(I2),0,DMT2R2,Z)
          DRM2R=DMT2R2/Z+DMT2R1/(1.0D0-Z)
          SPR=SQRT(DRM2R)

          IF(ARZCMS(S,SPR,SBP(5)).LT.0.0D0) GOTO 400

          PPRN = ARPCMS(S, SPR, SBP(5))
          PPRN1 = (1.0D0 - Z) * PPRN
          PMRN1 = DMT2R1/PPRN1
          PPRN2 = Z * PPRN
          PMRN2 = DMT2R2/PPRN2
          BP(I1,1) = PX
          BP(I1,2) = PY
          BP(I1,3) = (PPRN1-PMRN1)/2
          BP(I1,4) = (PPRN1+PMRN1)/2
          BP(I2,1) = -PX
          BP(I2,2) = -PY
          BP(I2,3) = (PPRN2-PMRN2)/2
          BP(I2,4) = (PPRN2+PMRN2)/2
 
        ENDIF

        PMN = ARPCMS(S, SBP(5), SPR)
        PMO = BP(IPART+3, 4) - BP(IPART+3, 3)
        PMBZ = (PMO**2 - PMN**2)/(PMN**2 + PMO**2)

        CALL ARROBO(0.0D0,0.0D0,0.0D0,0.0D0,PMBZ,INP,IPAR)

        CALL AROBO2(0.0D0,PHI3,0.0D0,0.0D0,0.0D0,I1,I2)
        CALL AROBO2(THE,PHI1,DBEX,DBEY,DBEZ,I1,I2)

        CALL ARROBO(0.0D0,PHI3,0.0D0,0.0D0,0.0D0,INP,IPAR)
        CALL ARROBO(THE,PHI1,DBEX,DBEY,DBEZ,INP,IPAR)

      ELSEIF( INQ(I1).LT.0.AND.INQ(I1).EQ.INQ(I3).AND.IFL(I2).NE.21)THEN
C...Undo a sea quark emission
C...Find all the partons apart from the quark and
C...proton remains that take part in the emission
        CALL ARFPA3(I1, I2, I3, IPAR, INP, SBP)
        IF(INP .LT. 1)THEN
          WRITE(*,*) 'ARUNDO: Error ARFPA3 found no particles'
        ENDIF
C...Sum the fourvectors
        DO 100 I = 1,5
          BP(IPART+1, I) = BP(I1, I) + BP(I3, I)
          BP(IPART+2, I) = BP(I2, I)
          BP(IPART+3, I) = SBP(I)
 100    CONTINUE
        BP(IPART+1, 5) = SQRT(ARMAS2(I1, I3))
C...Boost to CM
        CALL ARBCM3(IPART+1, IPART+2, IPART+3, THE, PHI1, PHI3, DBEX, 
     $    DBEY, DBEZ)
        S = ARMAS3(IPART+1, IPART+2, IPART+3)
C...Find the index of the proton remain to be created
        IF (  P(K(-INQ(I1), 3), 3) .GT. 0 )THEN
          IREST = MAXPAR-4
        ELSE
          IREST = MAXPAR-3
        ENDIF
        IF(QQ(IREST))THEN
          WRITE(*, *) 'Error in sea quark clusterisation'
          WRITE(*, *) 'Proton remain already exists'
        ENDIF

C...Set the KFSAVE vector
        IF(IREST.EQ.MAXPAR-4)THEN
          KFSAVE(1) = -IFL(I2)
        ELSE
          KFSAVE(2) = -IFL(I2)
        ENDIF

C...Set varibles for the new particles
        QQ(IREST) = .TRUE.
        PT2GG(IREST)=-1.0D0
        DO 110 I = 1,5
          BP(IREST, I) = BP(I1, I)
 110    CONTINUE

C...Boost all the particles to CM
        CALL AROBO2(0.0D0,0.0D0,-DBEX,-DBEY,-DBEZ,I3,IREST)
        CALL AROBO2(0.0D0,-PHI1,0.0D0,0.0D0,0.0D0,I3,IREST)
        CALL AROBO2(-THE,-PHI3,0.0D0,0.0D0,0.0D0,I3,IREST)

        CALL ARROBO(0.0D0,0.0D0,-DBEX,-DBEY,-DBEZ,INP,IPAR)
        CALL ARROBO(0.0D0,-PHI1,0.0D0,0.0D0,0.0D0,INP,IPAR)
        CALL ARROBO(-THE,-PHI3,0.0D0,0.0D0,0.0D0,INP,IPAR)
C...Change the mass and flavor keep Pplus constant
        IDUMMY = 0
        IFL(IREST) = 0
        DO 200 I = 1,1000
          CALL PYKFDI(IFL(I2), IFL(I1), IDUMMY, IFL(IREST))
          IF(IFL(IREST) .NE. 0) GOTO 210
 200    CONTINUE
 210    CONTINUE
        IF (IFL(IREST).EQ.0) 
     $       WRITE(*,*) 'ARUNDO: Unable to generate flavor'
        BP(IREST, 5) = PYMASS(IFL(IREST))        
        PPLUS = BP(IREST, 4) + BP(IREST, 3)
        PMINUS = (BP(IREST, 5)**2 + BP(IREST, 1)**2 + BP(IREST, 2)**2)/
     $    PPLUS
        BP(IREST, 4) = (PPLUS + PMINUS)/2
        BP(IREST, 3) = (PPLUS - PMINUS)/2

        IDI(IREST)=0
        IF ( MHAR(184).EQ.2 ) IDI(IREST) = MAXPAR-2
        IDO(IREST) = -IFL(I2)
        QEX(IREST) = .TRUE.
        INO(IREST) = IFL(I1)
        INQ(IREST) = I3
        XPMU(IREST) = XPMU(I1)
        XPA(IREST) = XPA(I1)

C...Rotate the particles
        ALP=ARANGL(IPART+1, IPART+3)
        PSI=(ARX2DB(PARU(1))-ALP)

        CALL ARROBO(PSI,0.0D0,0.0D0,0.0D0,0.0D0,INP,IPAR)
        CALL AROBO1(PSI,0.0D0,0.0D0,0.0D0,0.0D0,IPART+3)

C...Calculate the boosts for the particles involved
        PPN = ARPCMS(S, SQRT(ARMAS2(IREST, I3)), SBP(5))
        PPO = BP(IREST, 4) + BP(I3, 4) + BP(IREST, 3) + BP(I3, 3)
        PPBZ = (PPN**2 - PPO**2)/(PPN**2 + PPO**2)

        PMN = ARPCMS(S, SBP(5), SQRT(ARMAS2(IREST, I3)))
        PMO = BP(IPART+3, 4) - BP(IPART+3, 3)
        PMBZ = (PMO**2 - PMN**2)/(PMN**2 + PMO**2)

C...Boost back everything
        CALL AROBO2(0.0D0,0.0D0,0.0D0,0.0D0,PPBZ,I3,IREST)
        IF ( INP.GT.1 ) THEN
           CALL ARROBO(0.0D0,0.0D0,0.0D0,0.0D0,PMBZ,INP,IPAR)
        ELSE
           BP(IPAR(1),3)=0.5*((BP(IPAR(1),5)**2)/PMN-PMN)
           BP(IPAR(1),4)=0.5*((BP(IPAR(1),5)**2)/PMN+PMN)
        ENDIF
        CALL AROBO2(0.0D0,PHI3,0.0D0,0.0D0,0.0D0,I3,IREST)
        CALL AROBO2(THE,PHI1,DBEX,DBEY,DBEZ,I3,IREST)

        CALL ARROBO(0.0D0,PHI3,0.0D0,0.0D0,0.0D0,INP,IPAR)
        CALL ARROBO(THE,PHI1,DBEX,DBEY,DBEZ,INP,IPAR)

C...Remove particles and strings
        IF(IDI(I1) .GT. 0)THEN
          ID = IDI(I1)
        ELSE
          ID = IDO(I1)
        ENDIF
        CALL ARREMS(ISTR(ID))
        CALL ARREMD(ID)
        IF(I1 .GT. I2) THEN
          CALL ARREMP(I1)
          CALL ARREMP(I2)
        ELSE
          CALL ARREMP(I2)
          CALL ARREMP(I1)
        ENDIF

      ELSE IF(IFL(I2) .EQ. 21 .AND. (INQ(I1) .LT. 0 
     $    .OR. INQ(I3) .LT. 0) .AND. QQ(MAXPAR-2))THEN
C...Treat gluon emission from an extended source
C...Boost to CM
        CALL ARBCM2(I1,I3,THE,PHI1,DBEX,DBEY,DBEZ)
C...Boost I2 and MAXPAR-2 to the same system
        CALL AROBO2(0.0D0,0.0D0,-DBEX,-DBEY,-DBEZ,I2,MAXPAR-2)
        CALL AROBO2(0.0D0,-PHI1,0.0D0,0.0D0,0.0D0,I2,MAXPAR-2)
        CALL AROBO2(-THE,0.0D0,0.0D0,0.0D0,0.0D0,I2,MAXPAR-2)
C...Calculate the new momenta for the MAXPAR-2 particle
C...Let the particle MAXPAR-2 take the pt recoil
        BP(MAXPAR-2,1) = BP(MAXPAR-2,1) + BP(I2,1)
        BP(MAXPAR-2,2) = BP(MAXPAR-2,2) + BP(I2,2)
        A = SQRT((BP(MAXPAR-2,5)**2 + BP(MAXPAR-2,1)**2 + 
     $    BP(MAXPAR-2,2)**2)/(BP(MAXPAR-2,4)**2-BP(MAXPAR-2,3)**2))

C...PPlus and PMinus after reconstruction
        CPLUS = (1-A) * (BP(MAXPAR-2,4)+BP(MAXPAR-2,3)) +
     $       BP(I1,4)+BP(I1,3) + BP(I2,4)+BP(I2,3) +
     $       BP(I3,4)+BP(I3,3)
        CMINUS = (1-A) *(BP(MAXPAR-2,4)-BP(MAXPAR-2,3))
     $       + BP(I1,4)-BP(I1,3) + BP(I2,4)-BP(I2,3) +
     $       BP(I3,4)-BP(I3,3)
        IF(CMINUS .LE. 0 .OR. CPLUS .LE. 0 .OR. SQRT(CMINUS*CPLUS) 
     $       .LE. BP(I1,5)+BP(I3,5)+1 .OR.(
     $       .NOT. (QEX(I1).AND.QEX(I3)) 
     $       .AND. ( 
     $       ((BP(I2,4)+BP(I2,3)) .GT. A*(BP(MAXPAR-2,4)
     $       +BP(MAXPAR-2,3))) .OR. ((BP(I2,4)-BP(I2,3)).GT.
     $       A*(BP(MAXPAR-2,4)-BP(MAXPAR-2,3))) ) ) )THEN
C...Add a margin of 1GeV to avoid bad kinematics
C...Check if the gluon has a higher pplus or pminus than the gluon

C...It's not possible to give the recoil to MAXPAR-2
C...Undo everything and give the recoil to one of the particles
C...participating preferably not the extended particle
          BP(MAXPAR-2,1) = BP(MAXPAR-2,1) - BP(I2,1)
          BP(MAXPAR-2,2) = BP(MAXPAR-2,2) - BP(I2,2)
          CALL AROBO4(THE,PHI1, DBEX, DBEY, DBEZ, I1, I2, I3, MAXPAR-2)
          IF(INQ(I1) .GE. 0)THEN
            IT = I1
            I1 = I3
            I3 = IT
          ENDIF
          CALL ARBCM3(I1,I2,I3,THE,PHI1,PHI3,DBEX,DBEY,DBEZ)
          S = ARMAS3(I1,I2,I3)
C...Set momenta of the radiating partons
          BP(I1,1)=0.0D0
          BP(I1,2)=0.0D0
          BP(I1,3)=ARZCMS(S,BP(I1,5),BP(I3,5))
          BP(I1,4)=SQRT(BP(I1,1)**2+BP(I1,2)**2+BP(I1,3)**2+BP(I1,5)**2)
          BP(I3,1)=0.0D0
          BP(I3,2)=0.0D0
          BP(I3,3)=-BP(I1,3)
          BP(I3,4)=SQRT(BP(I3,1)**2+BP(I3,2)**2+BP(I3,3)**2+BP(I3,5)**2)
          CALL AROBO2(0.0D0,PHI3,0.0D0,0.0D0,0.0D0,I1,I3)
          CALL AROBO2(THE,PHI1,DBEX,DBEY,DBEZ,I1,I3)
        ELSE
          BP(MAXPAR-2,4) = A*BP(MAXPAR-2,4)
          BP(MAXPAR-2,3) = A*BP(MAXPAR-2,3)
C...Calculate the boosts
          S = CPLUS*CMINUS
          BZ = (CPLUS-CMINUS)/(CPLUS+CMINUS)
          CALL AROBO2(0.0D0,0.0D0,0.0D0,0.0D0,-BZ,I1,I3)
          PPN = ARPCMS(S, BP(I1,5), BP(I3,5))
          PPO = BP(I1,4) + BP(I1,3)
          PPBZ = (PPN**2 - PPO**2)/(PPN**2 + PPO**2)
          
          PMN = ARPCMS(S, BP(I3,5), BP(I1,5))
          PMO = BP(I3,4) - BP(I3,3)
          PMBZ = (PMO**2 - PMN**2)/(PMN**2 + PMO**2)
          CALL AROBO1(0.0D0,0.0D0,0.0D0,0.0D0,PPBZ,I1)
          CALL AROBO1(0.0D0,0.0D0,0.0D0,0.0D0,PMBZ,I3)
          CALL AROBO2(0.0D0,0.0D0,0.0D0,0.0D0,BZ,I1,I3)
C...Boost back to lab frame
          CALL AROBO3(THE,PHI1, DBEX, DBEY, DBEZ, I1, I3, MAXPAR-2)
        ENDIF
C...Remove the gluon        
        CALL ARREMG(I2)
      ELSE
        I3T=0
        IF ( QEX(I3) ) THEN
          IF ( QQ(MAXPAR-4).AND.INQ(MAXPAR-4).EQ.I3 ) THEN
            I3T = IPART+1
            I3P = MAXPAR-4
          ELSEIF ( QQ(MAXPAR-3).AND.INQ(MAXPAR-3).EQ.I3 ) THEN
            I3T = IPART+1
            I3P = MAXPAR-3
          ENDIF
        ENDIF
        I1T=0
        IF ( QEX(I1) ) THEN
          IF ( QQ(MAXPAR-4).AND.INQ(MAXPAR-4).EQ.I1 ) THEN
            I1T = IPART+2
            I1P = MAXPAR-4
          ELSEIF ( QQ(MAXPAR-3).AND.INQ(MAXPAR-3).EQ.I1 ) THEN
            I1T = IPART+2
            I1P = MAXPAR-3
          ENDIF
        ENDIF

        IF ( I1T.NE.0 ) THEN
          BP(I1T,1)=BP(I1,1)+BP(I1P,1)
          BP(I1T,2)=BP(I1,2)+BP(I1P,2)
          BP(I1T,3)=BP(I1,3)+BP(I1P,3)
          BP(I1T,4)=BP(I1,4)+BP(I1P,4)
          BP(I1T,5)=SQRT(MAX(0.0D0,BP(I1T,4)**2-BP(I1T,3)**2
     $         -BP(I1T,2)**2-BP(I1T,1)**2))
          I1=I1T
          QEX(I1)=.TRUE.
          IFL(I1)=IFL(I1I)
        ENDIF
        IF ( I3T.NE.0 ) THEN
          BP(I3T,1)=BP(I3,1)+BP(I3P,1)
          BP(I3T,2)=BP(I3,2)+BP(I3P,2)
          BP(I3T,3)=BP(I3,3)+BP(I3P,3)
          BP(I3T,4)=BP(I3,4)+BP(I3P,4)
          BP(I3T,5)=SQRT(MAX(0.0D0,BP(I3T,4)**2-BP(I3T,3)**2
     $         -BP(I3T,2)**2-BP(I3T,1)**2))
          I3=I3T
          QEX(I3)=.TRUE.
          IFL(I3)=IFL(I3I)
        ENDIF

C...Treat normal gluon or quark anti-quark emission
        S=ARMAS3(I1,I2,I3)
C...Boost to CM frame orient everything according to most likely recoil
        CALL ARBCM3(I1,I2,I3,THE,PHI1,PHI3,DBEX,DBEY,DBEZ)
        ALP=ARANGL(I1,I3)
        B1=BP(I1,4)
        B3=BP(I3,4)
        PSI=0
        IF ( IFL(I2).EQ.21 ) THEN
          IF ( QEX(I1).OR.QEX(I3) ) THEN
            IF ( QEX(I1).AND.QEX(I3) ) THEN
              PSI=(ARX2DB(PARU(1))-ALP)*(B3**2)/(B1**2+B3**2)
            ELSEIF ( QEX(I3) ) THEN
              PSI=(ARX2DB(PARU(1))-ALP)
            ENDIF
          ELSE
            IF ( (IFL(I1).EQ.21.AND.IFL(I3).EQ.21).OR.
     $           (IFL(I1).NE.21.AND.IFL(I3).NE.21).OR.
     $           MHAR(166).EQ.2 ) THEN
              PSI=(ARX2DB(PARU(1))-ALP)*(B3**2)/(B1**2+B3**2)
            ELSEIF ( IFL(I3).EQ.21 )  THEN
              PSI=(ARX2DB(PARU(1))-ALP)
            ENDIF
          ENDIF
        ELSE
          BP(I3,5)=0.0D0
        ENDIF
        CALL AROBO3(PSI,0.0D0,0.0D0,0.0D0,0.0D0,I1,I2,I3)
        IF ( I1.NE.I1I ) THEN
          CALL AROBO2(0.0D0,0.0D0,-DBEX,-DBEY,-DBEZ,I1I,I1P)
          CALL AROBO2(0.0D0,-PHI1,0.0D0,0.0D0,0.0D0,I1I,I1P)
          CALL AROBO2(-THE,0.0D0,0.0D0,0.0D0,0.0D0,I1I,I1P)
          CALL AROBO2(0.0D0,-PHI3,0.0D0,0.0D0,0.0D0,I1I,I1P)
          CALL AROBO2(PSI,0.0D0,0.0D0,0.0D0,0.0D0,I1I,I1P)
        ENDIF
        IF ( I3.NE.I3I ) THEN
          CALL AROBO2(0.0D0,0.0D0,-DBEX,-DBEY,-DBEZ,I3I,I3P)
          CALL AROBO2(0.0D0,-PHI1,0.0D0,0.0D0,0.0D0,I3I,I3P)
          CALL AROBO2(-THE,0.0D0,0.0D0,0.0D0,0.0D0,I3I,I3P)
          CALL AROBO2(0.0D0,-PHI3,0.0D0,0.0D0,0.0D0,I3I,I3P)
          CALL AROBO2(PSI,0.0D0,0.0D0,0.0D0,0.0D0,I3I,I3P)
        ENDIF

C...Set momenta of the radiating partons
        BP(I1,1)=0.0D0
        BP(I1,2)=0.0D0
        BP(I1,3)=ARZCMS(S,BP(I1,5),BP(I3,5))
        BP(I1,4)=SQRT(BP(I1,1)**2+BP(I1,2)**2+BP(I1,3)**2+BP(I1,5)**2)
        BP(I3,1)=0.0D0
        BP(I3,2)=0.0D0
        BP(I3,3)=-BP(I1,3)
        BP(I3,4)=SQRT(BP(I3,1)**2+BP(I3,2)**2+BP(I3,3)**2+BP(I3,5)**2)

        IF ( I1.NE.I1I ) THEN
          DPO2=(BP(I1I,4)+BP(I1P,4)+BP(I1I,3)+BP(I1P,3))**2
          DPN2=(BP(I1,4)+BP(I1,3))**2
          CALL AROBO2(0.0D0,0.0D0,0.0D0,0.0D0,
     $         (DPN2-DPO2)/(DPN2+DPO2),I1I,I1P)
          CALL AROBO2(-PSI,0.0D0,0.0D0,0.0D0,0.0D0,I1I,I1P)
          CALL AROBO2(0.0D0,PHI3,0.0D0,0.0D0,0.0D0,I1I,I1P)
          CALL AROBO2(THE,PHI1,DBEX,DBEY,DBEZ,I1I,I1P)
        ENDIF
        IF ( I3.NE.I3I ) THEN
          DMO2=(BP(I3I,4)+BP(I3P,4)-BP(I3I,3)-BP(I3P,3))**2
          DMN2=(BP(I3,4)-BP(I3,3))**2
          CALL AROBO2(0.0D0,0.0D0,0.0D0,0.0D0,
     $         (DMO2-DMN2)/(DMO2+DMN2),I3I,I3P)
          CALL AROBO2(-PSI,0.0D0,0.0D0,0.0D0,0.0D0,I3I,I3P)
          CALL AROBO2(0.0D0,PHI3,0.0D0,0.0D0,0.0D0,I3I,I3P)
          CALL AROBO2(THE,PHI1,DBEX,DBEY,DBEZ,I3I,I3P)
        ENDIF
         

C...Now boost back everything
        CALL AROBO2(-PSI,0.0D0,0.0D0,0.0D0,0.0D0,I1,I3)
        CALL AROBO2(0.0D0,PHI3,0.0D0,0.0D0,0.0D0,I1,I3)
        CALL AROBO2(THE,PHI1,DBEX,DBEY,DBEZ,I1,I3)

C...Remove the radiated parton
        IF ( IFL(I2).EQ.21 ) THEN
          CALL ARREMG(I2)
        ELSE
          IF ( I2.LT.I3 ) THEN
            DO 120 J=1,5
              BP(I2,J)=BP(I3,J)
 120        CONTINUE
          ENDIF
          CALL ARJOQQ(I2,I3)
        ENDIF
      ENDIF
      RETURN

C**** END OF ARUNDO ****************************************************
      END
