C***********************************************************************
C $Id: arptca.f,v 3.7 2004/08/17 13:45:14 leif Exp $

      DOUBLE PRECISION FUNCTION ARPTCA()

C...ARiadne function Cut on PT for all partons.

C...Return negative if any parton could have come from an emission with
C...pt less than the cutoff.

      INCLUDE 'arimpl.f'
      INCLUDE 'arpart.f'
      INCLUDE 'ardips.f'
      INCLUDE 'arstrs.f'
      INCLUDE 'ardat1.f'
      INCLUDE 'arhide.f'


      INXTP(I)=IP3(IDO(I))
      IPRVP(I)=IP1(IDI(I))


      ARPTCA=-1.0D0

      DO 100 I=1,IPART
C...Don't consider extended partons (remnants).
        IF ( QEX(I) ) GOTO 100
C...The easy case of gluon emission
        IF ( IFL(I).EQ.21.AND.(MHAR(167).LT.8.OR.INO(I).GE.0) ) THEN
          IF ( ARIPT2(IPRVP(I),I,INXTP(I)).LT.DBLE(PARA(3))**2 )
     $         RETURN
        ELSEIF ( IFL(I).NE.21 ) THEN
C...This is a quark. Find parton in this string which could have been
C...part of the emitting dipole
          ID=IDO(I)
          IF ( ID.GT.0 ) THEN
            IP=IP3(ID)
          ELSE
            ID=IDI(I)
            IP=IP1(ID)
          ENDIF
          IS=ISTR(ID)
C...Find corresponding antiquark in another string
          DO 110 IQB=1,IPART
C...Don't consider extended partons (remnants) except if we could have a
C...sea-quark emission.
            IF ( QEX(IQB) ) THEN
              IF ( MHAR(167).GE.9.AND.
     $             QEX(IP).AND.INQ(IP).EQ.INQ(IQB).AND.IQB.NE.IP ) THEN
                IF ( ARPT2S(IP,I,IQB).LT.DBLE(PARA(3)**2) ) RETURN
              ENDIF
              GOTO 110
            ENDIF
            IF ( IFL(IQB).NE.-IFL(I) ) GOTO 110
            IP2=0
            IF ( IDO(IQB).GT.0 ) THEN
              IP2=IP3(IDO(IQB))
              IF ( ISTR(IDO(IQB)).EQ.IS ) GOTO 110
            ELSE
              IP2=IP1(IDI(IQB))
              IF ( ISTR(IDI(IQB)).EQ.IS ) GOTO 110
            ENDIF
C...Check that neighboring partons are not remnants of the same particle
            IF ( QEX(IP).AND.QEX(IP2).AND.INQ(IP).EQ.INQ(IP2) ) GOTO 110
            IF ( ARIPT2(IP,I,IQB).LT.DBLE(PARA(3))**2 ) RETURN
 110      CONTINUE
        ENDIF
 100  CONTINUE

      ARPTCA=1.0D0

      RETURN

C**** END OF ARPTCA ****************************************************
      END
